Package org.eclipse.jdt.ui.text.java

# Interface IJavaCompletionProposalComputer

public interface IJavaCompletionProposalComputer
Computes completions and context information displayed by the Java editor content assistant. Contributions to the `org.eclipse.jdt.ui.javaCompletionProposalComputer` extension point must implement this interface.

Since:
  3.2

## Method Summary

Modifier and Type
Method
Description
`List<ICompletionProposal>`
`computeCompletionProposals(ContentAssistInvocationContext context, IProgressMonitor monitor)`
Returns a list of completion proposals valid at the given invocation context.
`List<IContextInformation>`
`computeContextInformation(ContentAssistInvocationContext context, IProgressMonitor monitor)`
Returns context information objects valid at the given invocation context.
`String`
`getErrorMessage()`
Returns the reason why this computer was unable to produce any completion proposals or context information.
`void`
`sessionEnded()`
Informs the computer that a content assist session has ended.
`void`
`sessionStarted()`
Informs the computer that a content assist session has started.

## Method Details

### sessionStarted

void sessionStarted()
Informs the computer that a content assist session has started. This call will always be followed by a `sessionEnded()` call, but not necessarily by calls to computeCompletionProposals or computeContextInformation.

### computeCompletionProposals

List<ICompletionProposal> computeCompletionProposals(ContentAssistInvocationContext context, IProgressMonitor monitor)
Returns a list of completion proposals valid at the given invocation context.

Parameters:
  `context` - the context of the content assist invocation
  `monitor` - a progress monitor to report progress. The monitor is private to this invocation, i.e. there is no need for the receiver to spawn a sub monitor.
Returns:
  a list of completion proposals (element type: `ICompletionProposal`)

### computeContextInformation

List<IContextInformation> computeContextInformation(ContentAssistInvocationContext context, IProgressMonitor monitor)
Returns context information objects valid at the given invocation context.

Parameters:
  `context` - the context of the content assist invocation
  `monitor` - a progress monitor to report progress. The monitor is private to this invocation, i.e. there is no need for the receiver to spawn a sub monitor.
Returns:
  a list of context information objects (element type: `IContextInformation`)

### getErrorMessage

String getErrorMessage()
Returns the reason why this computer was unable to produce any completion proposals or context information.

Returns:
  an error message or `null` if no error occurred

### sessionEnded

void sessionEnded()
Informs the computer that a content assist session has ended. This call will always be after any calls to computeCompletionProposals and computeContextInformation.